
User Interface - Feature #2959

Implement search by key in browse

01/18/2016 11:08 AM - Stanislav Lomany

Status: Closed Start date: 01/18/2016

Priority: Normal Due date:  

Assignee: Stanislav Lomany % Done: 100%

Category:  Estimated time: 0.00 hour

Target version:    

billable: No version:  

vendor_id: GCD   

Description

Related issues:

Related to User Interface - Feature #2564: implement GUI BROWSE widget Closed

History

#1 - 01/18/2016 01:48 PM - Stanislav Lomany

When a key is pressed in non-editable browse, browse searches for the next row which starts with the pressed key.

1. Search is performed using only the first character in the first column.

2. The full set of charaters the browse reacts to is to be investigated, but most likely it matches the set of printable characters.

3. Browse looks for the next row (in browse display order) which starts with the given character. If not found, search is continued from the top. If not

found from the top and the current row matches the key, search returns to the current row (it is considered as the found row and scrolling is

performed accordingly).

4. If found row is before the current top row in the view (according to the current size of the result set, deleted rows are not taken in consideration)

then browse is scrolled so the found row becomes the top row. Otherwise browse is scrolled so the found row becomes the bottom row.

5. If target row is in the view after the current row - no scrolling is performed, target row is selected.

6. If there is no found row and the current row is in the view or out of the view ABOVE it then the browse is scrolled up at maximum by (DOWN - 1)

till the current row becomes the bottom row or until we scrolled to the top or to the (DOWN - 1)th row above (according to the current size of the

result set, deleted rows are not taken in consideration). Current row remains the same.

7. If there is no found row and the current row is BELOW the view then nothing happens.

#2 - 01/25/2016 09:18 AM - Greg Shah

- Parent task deleted (#2564)

#3 - 01/28/2016 09:15 AM - Greg Shah

This task must also implement ALLOW-COLUMN-SEARCHING and the START-SEARCH and END-SEARCH events.  See #2564-276 (and note

277) for details.

#4 - 08/02/2016 11:07 AM - Stanislav Lomany

- Status changed from New to WIP

- File brws-search.p added

05/19/2024 1/12

https://proj.goldencode.com/issues/2564#note-276


There are two mechanics about "column searching":

1. Search mechanics.

Pressing a printable character causes scrolling to the next row, which has the target column starting with the given character. Scrolling doesn't

happen if there is a trigger bound to that character.

If ALLOW-COLUMN-SEARCHING is false the target column is always the first column.

If ALLOW-COLUMN-SEARCHING is true the target column is the current "pressed" column.

2. Sort mechanics.

If ALLOW-COLUMN-SEARCHING is true: user is given the ability to control browse scrolling by pressing column headers. User has to implement

START-SEARCH trigger where he should reopen queries with target ... BY ... ASC/DESC clause. There are also available:

END-SEARCH event;

browse:CURRENT-COLUMN attribute;

column:SORT-ASCENDING attribute which, in addition, displays sorting arrows on columns.

There is the testcase which demonstrates these abilities.

I didn't find this mechanics in the customer's app.

What part(s) should I implement?

#5 - 08/02/2016 02:04 PM - Greg Shah

The app definitely does set ALLOW-COLUMN-SEARCHING = TRUE in multiple places.

I don't see any string literals that match start-search or end-search, which suggests that the app may not implement the events processing code.  But

the use of the attribute still probably changes behavior of the browse.

I'm imclined to just implement all of it now.  I do think it is important to get the feature right for the case where the triggers are missing for start-search

or end-search.  It is one thing to postpone work on quirks but these features seem pretty core.

#6 - 08/15/2016 07:49 AM - Stanislav Lomany

- File sort-number.png added

Greg, should I implement SORT-ASCENDING and SORT-NUMBER attributes for displaying sorting direction and sort-level number?
#7 - 08/15/2016 09:44 AM - Greg Shah

should I implement SORT-ASCENDING and SORT-NUMBER attributes for displaying sorting direction and sort-level number?

 

Yes, please do.

#8 - 08/17/2016 01:47 PM - Stanislav Lomany

Note that the pressed column header is some kind of rectangle with top-left shadow. We don't have this P2J so I've replaced it with the classical

rectangle which is the closest choice.

#9 - 08/17/2016 02:41 PM - Greg Shah

Note that the pressed column header is some kind of rectangle with top-left shadow. We don't have this P2J so I've replaced it with the classical

rectangle which is the closest choice.

 

Are you manually drawing the highlights using lines?

We had this same requirement for menus, if I recall correctly.  Probably, the right thing to do is to implement the primitive drawing function in both

drivers.
#10 - 08/17/2016 02:49 PM - Stanislav Lomany

Do you know if there are any other elements which should be drawn using not-raised 3D rect?

#11 - 08/17/2016 03:20 PM - Greg Shah

Do you know if there are any other elements which should be drawn using not-raised 3D rect?

 

Vadim/Hynek/Eugenie: Can any of you identify cases where this "inverted" highlight is simulated using manual drawing of the highlight.  I seem to

recall that we may do it for buttons and for menus, but I don't recall for sure.

#12 - 08/17/2016 05:33 PM - Eugenie Lyzenko

Greg Shah wrote:

Do you know if there are any other elements which should be drawn using not-raised 3D rect?

 

Vadim/Hynek/Eugenie: Can any of you identify cases where this "inverted" highlight is simulated using manual drawing of the highlight.  I seem

to recall that we may do it for buttons and for menus, but I don't recall for sure.

 

From my knowledge/work:

Push buttons, Fill-in and combo-box entry, Editor, Slider buttons, Toggle-box. I think everywhere when we need "inverted" highlight we need to

implement this simulation because draw3DRect() API does not exactly match the requirement to simulate pure Windows GUI parts for classic theme.

#13 - 08/18/2016 02:19 AM - Vadim Gindin

Eugenie Lyzenko wrote:

Greg Shah wrote:

Do you know if there are any other elements which should be drawn using not-raised 3D rect?

 

Vadim/Hynek/Eugenie: Can any of you identify cases where this "inverted" highlight is simulated using manual drawing of the highlight.  I

seem to recall that we may do it for buttons and for menus, but I don't recall for sure.
From my knowledge/work:

Push buttons, Fill-in and combo-box entry, Editor, Slider buttons, Toggle-box. I think everywhere when we need "inverted" highlight we need to

implement this simulation because draw3DRect() API does not exactly match the requirement to simulate pure Windows GUI parts for classic

theme.

 

I would also confirm that menu widgets need "inverted" highlight.

#14 - 08/18/2016 08:18 AM - Stanislav Lomany

Although these cases look similar I haven't seen another case with the inner top-left shadow with width 1px less than the actual width. I don't think we

can and should provide an unified solution.

#15 - 08/18/2016 10:42 AM - Greg Shah

Although these cases look similar I haven't seen another case with the inner top-left shadow with width 1px less than the actual width. I don't

think we can and should provide an unified solution.

 

I understand that you can use a manual drawing approach (rectangle and lines) to match the pixel by pixel result.  Perhaps this is the right thing to do.

But part of the problem here is that for 3D rectangle drawing, the shading colors are calculated automatically based on the rectangle color.  Today this

is done by the driver (actually Swing does it in the case of the Swing client, but for the web client we have our own calculation in the driver).

I suspect that all of the similar code where we manually draw will have the wrong shadow colors when we allow the customer to override colors and/or

when we allow switchable themes (#2676).

#16 - 08/18/2016 12:10 PM - Stanislav Lomany

In this case the shading color is constant. BTW, I didn't notice that it is also true for raised 3D headers, so I should manually draw this shadow for

both states of a column header.

#17 - 08/22/2016 07:18 PM - Stanislav Lomany

Created task branch 2959a from trunk revision 11084.

#18 - 08/31/2016 09:18 PM - Stanislav Lomany

At this point the sort mechanics from the note 4 is implemented for the most part - it still needs some pixel-perfect drawing work to be done. Search

mechanics from the same note was investigated but implementation hasn't started.

#19 - 09/19/2016 05:39 AM - Stanislav Lomany
Rebased task branch 2959a from P2J trunk revision 11095.

#20 - 11/09/2016 06:46 AM - Stanislav Lomany

Rebased task branch 2959a from P2J trunk revision 11128.

#21 - 01/25/2017 11:44 AM - Greg Shah

Code Review Task Branch 2929a Revision 11131

The changes look good.

It seems like most everything we need for #3228 is there.  It is not clear what needs to be done to stabilize this.  Other than rebasing and adding

history entries/javadoc, what else is needed for this?

#22 - 01/25/2017 11:50 AM - Constantin Asofiei

Ovidiu, can you take a look at searchpath in directory.xml, too?  From what I see, this is OS-dependent, too...

Meant for #3225

#23 - 01/27/2017 10:57 AM - Stanislav Lomany

Rebased task branch 2959a from P2J trunk revision 11140.

#24 - 01/27/2017 01:55 PM - Stanislav Lomany

It is not clear what needs to be done to stabilize this. Other than rebasing and adding history entries/javadoc, what else is needed for this?

 

There are visual issues in drawing sort arrows and numbers in columns header. We need to check if they are displayed in POC. So far I'm planning to

add javadoc to this branch and merge to 3209e.

#25 - 01/28/2017 07:58 AM - Greg Shah

When will you be able to merge into 3209e?  I need it to convert the POC code, which I'm trying to get done as early in the weekend as possible so

that I can start testing.  We need to get some idea of the issues that have to be resolved.

We need to check if they are displayed in POC.

 

Understood.  Are these related to the SORT-ASCENDING and SORT-NUMBER attributes?  If so then we are OK because those attributes are not

used in the POC code.
#26 - 01/28/2017 09:14 AM - Stanislav Lomany

When will you be able to merge into 3209e?

 

In an hour. Sorry for delay, I didn't think it is urgent.

Understood. Are these related to the SORT-ASCENDING and SORT-NUMBER attributes?

 

Yes. AFAIK they cannot be cannot be triggered by some in-browse actions, and have to be explicitly set. That is good. However I would like to take a

look how sorting actually works in POC, who knows what may emerge.

#27 - 01/28/2017 11:14 AM - Stanislav Lomany

Branch 2959a was merged into 3209e and archived. I'll add missing svg files later.

Please note I'll be unavailable for the rest of the day.

#28 - 03/20/2017 06:32 AM - Stanislav Lomany

Greg, I've working on sort arrow and sort number pixel-perfect positioning and drawing. In fact numbers are all 4*7 figures except symbol "1" which is

2*7. The font is unknown, but with a few pixels of difference, it is SmallFonts,7. Some notes:

1. Horizontally symbol "1" is positioned as it is a fixed-width font (while it doesn't look so visually).

2. Vertically numbers are positioned exactly in the middle, unlike column labels which are positioned in the middle according to the text metrics

(more space on top).

What I'm saying is that positioning sort numbers according to text metrics is possible only with some hard-coded offsets: vertical and, for "1":

horizontal.

I suspect that 4GL just uses bitmaps for this numbers (I haven't yet tried to check resources in 4GL files to prove that) and I suggest to go this way

too. What do you think?

#29 - 03/20/2017 09:04 AM - Greg Shah

I suspect that 4GL just uses bitmaps for this numbers (I haven't yet tried to check resources in 4GL files to prove that) and I suggest to go this

way too. What do you think?
I'm fine with this approach.

#30 - 03/21/2017 01:18 PM - Stanislav Lomany

Created task branch 2959b from trunk revision 11143.

#31 - 04/07/2017 03:33 PM - Stanislav Lomany

These rules describe how the row found by key is positioned in the view depending on 1. how the current row is positioned relatively to the view. 2.

how the found row is positioned relatively to the view and to the current row.

Meanings:

first page - current/found row is on the first page of the result set;

cycle - result wasn't found after the current row, search was continued from the top;

bottom - the view is scrolled so the found row becomes the bottom row;

top - the view is scrolled so the found row becomes the top row;

page up - current view is scrolled up by (DOWN - 1);

option 1 — current row becomes top row, found row is highlighted;

option 2 — scroll to first row in the result set, highlight found row;

option 3 — scroll to first row in the result set, highlight current;

X - this combination can't happen.

Note that unless "first page" is explicitly specified, the current/found row is NOT on the first page of the result set.
#32 - 04/08/2017 12:07 PM - Greg Shah

Nice work!

Does "X" mean "this combination can't happen"?

#33 - 04/08/2017 12:08 PM - Greg Shah

How much time is needed to create the implementation matching these rules?

#34 - 04/08/2017 07:22 PM - Stanislav Lomany

Does "X" mean "this combination can't happen"?

 

Yes. I've updated the legend.

How much time is needed to create the implementation matching these rules?

 

A couple of days.

#35 - 04/10/2017 09:13 AM - Constantin Asofiei

Stanislav, a question: if BROWSE is in focus and a printable key is pressed, if there is an ANYWHERE trigger (or another trigger which can catch it),

will the trigger be invoked?  If is invoked, how will search-by-key behave if the trigger has RETURN NO-APPLY (or not)?

#36 - 04/10/2017 09:15 AM - Stanislav Lomany

Stanislav, a question: if BROWSE is in focus and a printable key is pressed, if there is an ANYWHERE trigger (or another trigger which can

catch it), will the trigger be invoked?

 

Yes.

If is invoked, how will search-by-key behave if the trigger has RETURN NO-APPLY (or not)?

 

Search is not performed if there was a fired trigger.
#37 - 04/17/2017 12:32 PM - Stanislav Lomany

Rebased task branch 2959b from P2J trunk revision 11146.

#38 - 04/18/2017 08:41 AM - Stanislav Lomany

Rebased task branch 2959b from P2J trunk revision 11147.

#39 - 04/18/2017 08:50 AM - Stanislav Lomany

Please review task branch 2959b rev 11155.

#40 - 04/19/2017 01:37 PM - Constantin Asofiei

Stanislav Lomany wrote:

Please review task branch 2959b rev 11155.

 

Stanislav, the changes in 2959b look OK to me.

From what I see, search by key works only for the first char in the browse cell, correct?

#41 - 04/19/2017 04:32 PM - Stanislav Lomany

From what I see, search by key works only for the first char in the browse cell, correct?

 

Correct.

#42 - 04/19/2017 05:11 PM - Stanislav Lomany

Rebased task branch 2959b from P2J trunk revision 11148.

#43 - 04/20/2017 03:31 PM - Stanislav Lomany

Passed regression testing.

Rebased task branch 2959b from P2J trunk revision 11149.

Should I check in?

#44 - 04/20/2017 03:37 PM - Constantin Asofiei

Stanislav Lomany wrote:

Passed regression testing.

Rebased task branch 2959b from P2J trunk revision 11149.

Should I check in?
Yes, go ahead.

#45 - 04/20/2017 04:17 PM - Stanislav Lomany

2959b has been merged into the trunk as bzr revision 11150.

#46 - 04/20/2017 04:39 PM - Stanislav Lomany

- Status changed from WIP to Review

#47 - 04/20/2017 05:03 PM - Greg Shah

- % Done changed from 0 to 100

- Status changed from Review to Closed

#48 - 07/28/2017 08:58 AM - Greg Shah

Are there items implemented in 2959a and 2959b which need to be updated in our gap analysis marking?

#49 - 07/28/2017 11:15 AM - Stanislav Lomany

Are there items implemented in 2959a and 2959b which need to be updated in our gap analysis marking?

 

If you mean the list #3275-1 then no.

#50 - 07/28/2017 11:35 AM - Greg Shah

No, I'm referencing the changes made in this task.  For example, the existing marking for ALLOW-COLUMN-SORTING, SORT-ASCENDING,

SORT-NUMBER... are probably out of date now.  They are all working fully now in trunk, right?

Please make the updates in 1514a (@rules/gaps/expressions.rules) that match the state of the trunk in regard to 2959a and 2959b.  We are trying to

get a new drop of 1514a released, so doing this quickly would be appreciated.

#51 - 07/28/2017 12:48 PM - Stanislav Lomany

No, I'm referencing the changes made in this task.  For example, the existing marking for ALLOW-COLUMN-SORTING, SORT-ASCENDING,

SORT-NUMBER... are probably out of date now.  They are all working fully now in trunk, right?

 

Yes. I've made changes to rules/gaps/expressions.rules in 1514a.
#52 - 07/31/2017 04:07 AM - Stanislav Lomany

For dynamic browse one can set validation expression using VALIDATE-EXPRESSION and VALIDATE-MESSAGE attributes. However in P2J it is

implemented incorrectly: it sets expression/message globally rather than buffer-wide. Testcase:

FIND FIRST book.

DEF BUFFER book2 FOR book.

DEF VAR h AS HANDLE.

h = BUFFER book2:BUFFER-FIELD("book-id").

h:VALIDATE-EXPRESSION = "book-id > 55".

h = BUFFER book:BUFFER-FIELD("book-id").

MESSAGE h:VALIDATE-EXPRESSION. /* should NOT be "book-id > 55" */

Files

brws-search.p 2.16 KB 08/02/2016 Stanislav Lomany

sort-number.png 20.7 KB 08/15/2016 Stanislav Lomany
